"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rxjs = require("rxjs");

var _default = function _default(getStream) {
  return _rxjs.Observable.create(function (observer) {
    var stream = getStream();
    var done = false;

    var cleanup = function cleanup() {
      if (!done) {
        done = true; // eslint-disable-next-line

        stream.removeListener('end', onEnd); // eslint-disable-next-line

        stream.removeListener('error', onError); // eslint-disable-next-line

        stream.removeListener('data', onData);
      }
    };

    var onEnd = function onEnd() {
      cleanup();
      observer.complete();
    };

    var onError = function onError(error) {
      cleanup();
      observer.error(error);
    };

    var onData = function onData(data) {
      return observer.next(data);
    };

    stream.once('error', onError);
    stream.once('end', onEnd);
    stream.on('data', onData);
    return function () {
      return cleanup();
    };
  });
};

exports.default = _default;